#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

int main (int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    const string type = string(argv[1]);
    assert(type == "normal" || type == "big" || type == "diff");

    const int l = atoi(argv[2]);
    const int r = atoi(argv[3]);
    const int shift = atoi(argv[4]);

    vector<int> cnt(3);
    cnt[0] = rnd.next(l, r);

    if (type == "normal")
    {
        cnt[1] = rnd.next(l, r);
        cnt[2] = rnd.next(l, r);
    }
    else if (type == "big")
    {
        const int bnd = (cnt[0] + shift - 2);
        assert(bnd >= 1);

        while (cnt[2] <= 0 || max(cnt[1], cnt[2]) > cnt[0])
        {
            cnt[1] = rnd.next(1, bnd);
            cnt[2] = (bnd + 1) - cnt[1];
        }
    }
    else
    {
        cnt[1] = (cnt[0] * 3 / 4) + rnd.next(-shift, shift);
        cnt[2] = (cnt[0] * 2 / 4) + rnd.next(-shift, shift);
    }

    shuffle(cnt.begin(), cnt.end());
    cout << cnt[0] << ' ' << cnt[1] << ' ' << cnt[2] << endl;
}

