// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

alias Line = Tuple !(int, q{value}, int, q{moment});

void main ()
{
	string title;
	while ((title = readln.stripRight) != "")
	{
		int n;
		title.formattedRead !("for (int i = 0; i < %d; i++)") (n);
		int [] x;
		int [] y;
		while (true)
		{
			auto line = readln.stripRight;
			if (line == "    work (i);")
			{
				enforce (readln.stripRight == "}");
				break;
			}
			x ~= 0;
			y ~= 0;
			line.formattedRead !("    if (i == %d) i = %d;")
			    (x.back, y.back);
		}
		auto k = x.length.to !(int);
		debug {writeln (x);}
		debug {writeln (y);}

		auto s = redBlackTree !(Line);
		foreach (j; 0..k)
		{
			s.insert (Line (x[j], j));
		}
		long res = 2; // init, cmp
		long fullStep = k + 3;
		int value = 0;
		bool [int] vis;
		while (true)
		{
			if (value in vis)
			{
				res = -1;
				break;
			}
			vis[value] = true;

			auto nexts = s.upperBound (Line (value, -1));
			if (nexts.empty)
			{
				res += fullStep * (n - value);
				break;
			}
			auto next = nexts.front;
			int moment = next.moment;
			res += fullStep * (next.value - value) + moment + 2;
			value = y[moment];
			moment += 1;

			while (true)
			{
				auto temps = s.upperBound (Line (value, moment - 1));
				if (temps.empty || temps.front.value != value)
				{
					res += fullStep - moment;
					value += 1;
					break;
				}
				res += temps.front.moment - moment + 2;
				moment = temps.front.moment;
				value = y[moment];
				moment += 1;
			}
		}
		writeln (res);
	}
}
