/**
 * Validator for problem max-triangle.
 */

#include "testlib.h"

using namespace std;

constexpr int N = 1000;
constexpr int MAXC = 1000;

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);
  const int n = inf.readInt(1, N, "number of points");
  inf.readEoln();
  for (int i = 0; i < n; ++i) {
    inf.readInt(-MAXC, MAXC, "x[]");
    inf.readSpace();
    inf.readInt(-MAXC, MAXC, "y[]");
    inf.readEoln();
  }
  inf.readEof();
  return 0;
}
