#include "testlib.h"
#include "assert.h"

using namespace std;

void generate(int n, int m, int yes)
{
	const char symbols[5] = { 'A', 'R', 'C', 'I', '-'};

	cout << n << ' ' << m << endl;

	bool badA = false;

    int badLine = (yes >= 2) ? rnd.next(0, n - 1) : -1;
	for (int i = 0; i < n; ++i)
	{
		int cntA = 0;

        int posA = (yes >= 1) ? rnd.next(0, m - 1) : -1;
        int posB = -1;
        if (yes == 2 && badLine == i)
        {
            posB = rnd.next(0, m - 1);
        }
        if (yes == 3 && badLine == i)
        {
            posB = posA;
        }
		for (int j = 0; j < m; ++j)
		{
			auto s = symbols[rnd.next((yes > 0), 4)];
			if (posA == j)
			{
			    s = 'A';
			}
			if (posB == j && badLine == i)
			{
			    s = (posA == posB) ? '-' : 'A';
			}

			cout << s;

			if (s == 'A')
				cntA++;
			
			if (j != m - 1) 
				cout << ' ';
		}

		badA |= (cntA != 1);

		assert((yes != 1) || cntA == 1);

		cout << endl;
	}

	assert((yes == 1) || badA);
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    
	//generate(10, 10, false);

	generate(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]));

	return 0;
}

// script generator
/*int main()
{
	random_device dev;
	mt19937 rng(dev());
	uniform_int_distribution<std::mt19937::result_type> sizeDist(10, 100);
	uniform_int_distribution<std::mt19937::result_type> taskCountDist(1, 10);
	uniform_int_distribution<std::mt19937::result_type> yesNoDist(0, 1);

	set<string> gens;

	for (int test = 6; test <= 50; ++test)
	{
		int n = sizeDist(rng);
		int m = sizeDist(rng);
		int yes = yesNoDist(rng);

		gens.emplace("generator " + to_string(n) + ' ' + to_string(m) + ' ' + to_string(yes));
	}

	int test = 6;
	for (auto gen : gens)
	{
		cout << gen << " > " << test << endl;
		++test;
	}

	return 0;
}*/