#include "bits/stdc++.h"
#include <random>

using namespace std;

mt19937 rng;

void generate(int n, int m, bool yes)
{
	const char symbols[5] = { 'R', 'A', 'C', 'I', '-'};

	uniform_int_distribution<std::mt19937::result_type> dist(0, 4);

	cout << n << ' ' << m << endl;

	bool badA = false;

	for (int i = 0; i < n; ++i)
	{
		bool cntA = 0;

		for (int j = 0; j < m; ++j)
		{
			auto s = symbols[dist(rng)];

			if (yes)
			{
				if (cntA == 0 && j == m - 1)
					s = 'A';
				else if (s == 'A' && cntA == 1)
					s = '-';
			}

			cout << s;

			if (s == 'A')
				cntA++;
			
			if (j != m - 1) 
				cout << ' ';
		}

		badA |= (cntA != 1);

		assert(!yes || cntA == 1);

		if (i != n - 1)
			cout << endl;
	}

	assert(yes || badA);
}

int main(int argc, char* argv[])
{
	random_device dev;
	rng = mt19937(dev());

	//generate(15, 7, false);

	generate(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]) == 1);

	return 0;
}

// script generator
/*int main()
{
	random_device dev;
	mt19937 rng(dev());
	uniform_int_distribution<std::mt19937::result_type> sizeDist(10, 100);
	uniform_int_distribution<std::mt19937::result_type> taskCountDist(1, 10);
	uniform_int_distribution<std::mt19937::result_type> yesNoDist(0, 1);

	set<string> gens;

	for (int test = 6; test <= 50; ++test)
	{
		int n = sizeDist(rng);
		int m = sizeDist(rng);
		int yes = yesNoDist(rng);

		gens.emplace("generator " + to_string(n) + ' ' + to_string(m) + ' ' + to_string(yes));
	}

	int test = 6;
	for (auto gen : gens)
	{
		cout << gen << " > " << test << endl;
		++test;
	}

	return 0;
}*/