import sys

def rs():
  return sys.stdin.readline().rstrip().split()

S = set(['R', 'A', 'C', 'I', '-'])

def read_job(m):
  s = ''.join(rs())
  assert len(s) == m
  assert all(c in S for c in s)
  return s

def raci(s):
  return all(map(lambda t: t.count('A') == 1 and t.count('R') <= 1, s))

def main():
  n, m = map(int, rs())
  assert 1 <= n <= 100
  assert 1 <= m <= 100
  print('Yes' if raci([read_job(m) for _ in range(n)]) else 'No')

main()
