// Author: Ivan Kazmenko (gassa@mail.ru)
// count commas on depth 1
module solution;
import std;

int solve (string s)
{
	if (s == "{}")
	{
		return 0;
	}
	int res = 1;
	int balance = 0;
	foreach (ref c; s)
	{
		if (c == '{')
		{
			balance += 1;
		}
		else if (c == '}')
		{
			balance -= 1;
		}
		else if (balance == 1)
		{
			res += 1;
		}
	}
	return res;
}

void main ()
{
	string s;
	while ((s = readln.strip) != "")
	{
		writeln (solve (s));
	}
}
