#include "testlib.h"
 
#include <iostream>
#include <set>
#include <cassert>
#include<vector>
 
using ll = long long; 
using namespace std;
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	const int maxn = atoi(argv[1]);
	const int maxk = atoi(argv[2]);
 
	cout << maxn << endl;
	vector<vector<pair<int,ll>>>tree(maxn);
	for (int i = 1; i < maxn; i++)
	{
	    auto vert = rnd.next(i);
		auto len = rnd.next(maxk) + 1;
		tree[i].push_back({vert,len});
		tree[vert].push_back({i,len});
		
	}
	vector<vector<ll>>my_dists(maxn, vector<ll>(maxn, 0));
	for (int root = 0; root < maxn; root++)
	{
		for(int i=0; i<root; i++)
		{
		    int val=rnd.next(maxk)+1;
		    my_dists[root][i]=val;
		    my_dists[i][root]=val;
		}
	}
	for(int i=0; i<maxn; i++)
	{
	    for(int j=0; j<maxn; j++)
	    {
	        if(j!=maxn-1)
	           cout<<my_dists[i][j]<<' ';
	        else
	           cout<<my_dists[i][j]<<'\n';
	    }
	}
}