//#include "bits/stdc++.h"
#include <string>
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <stack>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <math.h>
#include <iomanip>  
#include <queue>
#include <iostream>
#include <sstream>
#include <cassert>
#include <unordered_map>

using namespace std;

void solve(int n)
{
	vector<string> programs(n);
	for (int i = 0; i < n; ++i)
		cin >> programs[i];

	char table[5][6];
	for (int i = 0; i < 5; ++i)
		for (int j = 0; j < 6; ++j)
			table[i][j] = '.';

	for (const auto& program : programs)
	{
		char first = program[0];
		assert(first >= 'a' && first <= 'z');

		int index = first - 'a'; 
		int row = index / 6; 
		int col = index % 6; 
		table[row][col] = first;
	}

	for (int i = 0; i < 5; ++i)
	{
		for (int j = 0; j < 6 && i * 6 + j < 26; ++j)
			cout << table[i][j];

		cout << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	while (cin >> n)
		solve(n);

	return 0;
}
