#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

const int full = (1 << 7) - 1;
int take (const int i)
{
    return (1 << i);
}

bool get (const int mask, const int i)
{
    return bool((mask >> i) & 1);
}

const array<int, 10> masks = {full - take(3), take(2) + take(5), full - take(1) - take(5),
                              full - take(1) - take(4), take(1) + take(2) + take(3) + take(5),
                              full - take(2) - take(4), full - take(2), take(0) + take(2) + take(5),
                              full, full - take(4)};

int main()
{
    for (int i = 0; i < int(masks.size()); i++)
    {
        const int x = masks[i];

        vector<string> ans(5, string(3, '.'));
        if (get(x, 0))
            ans[0] = "xxx";
        if (get(x, 1))
            ans[0][0] = ans[1][0] = ans[2][0] = 'x';
        if (get(x, 2))
            ans[0][2] = ans[1][2] = ans[2][2] = 'x';
        if (get(x, 3))
            ans[2] = "xxx";
        if (get(x, 4))
            ans[2][0] = ans[3][0] = ans[4][0] = 'x';
        if (get(x, 5))
            ans[2][2] = ans[3][2] = ans[4][2] = 'x';
        if (get(x, 6))
            ans[4] = "xxx";

        cout << "for " << i << ":" << endl;
        for (const auto &str : ans)
            cout << str << endl;
        cout << endl << endl;
    }

    vector<vector<char>> can(10, vector<char>(10));

    for (int survive = 0; survive <= full; survive++)
    {
        array<int, 10> become;
        fill(become.begin(), become.end(), -1);
        for (int i = 0; i < 10; i++)
        {
            const int new_mask = (masks[i] & survive);
            const int pos = int(find(masks.begin(), masks.end(), new_mask) - masks.begin());
            if (pos != int(masks.size()))
            {
                can[i][pos] = 1;
                become[i] = pos;
            }
        }

        int incr = 1;
        for (int start = 0; start < 10; start++)
        {
            int cur_incr = 1, from = start;
            while (become[from] != -1)
            {
                const int next_from = (from + 9) % 10;
                if (become[next_from] != (become[from] + 1) % 10)
                    break;
                from = next_from;
                cur_incr++;
            }

            incr = max(incr, cur_incr);
        }

        if (survive == full - take(2))
        {
            cout << survive << "->" << "increasing for " << incr << " steps" << endl;
            for (const auto it : become)
                cout << (it == -1 ? '-' : char('0' + it)) << ' ';
            cout << endl;
        }
    }

//    for (int i = 0; i < 10; i++)
//    for (int j = 0; j < 10; j++)
//    if (can[i][j])
//    {
//        cout << i << "->" << j << endl;
//    }
}
