#include "testlib.h"

const uint32_t MAX_N = 200'000;
const uint32_t MAX_A = 1'000'000'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    uint32_t n = inf.readInt(2, MAX_N, "n");
    inf.readEoln();
    for (uint32_t i = 0; i < n; ++i) {
        inf.readInt(1, MAX_A, std::format("a[{}]", i + 1));
        if (i == n - 1) inf.readEoln();
        else inf.readSpace();
    }
    uint32_t s = inf.readInt(1, MAX_N, "s");
    inf.readSpace();
    uint32_t t = inf.readInt(1, MAX_N, "t");
    ensuref(s != t, "%s", std::format("s == t == {}, but these cities should differ", s).c_str());
    inf.readEoln();
    inf.readEof();
}
