// Author: Ivan Kazmenko (gassa@mail.ru)
// parse and validate string
module solution;
import std;

int solve (ref string s)
{
	int balance = 0;
	enforce (!s.empty && s.front == '{');
	s.popFront;
	int [] v;
	bool start = false;
	while (s.front != '}')
	{
		if (start)
		{
			enforce (s.front == ',');
			s.popFront;
			enforce (!s.empty);
		}
		else
		{
			start = true;
		}
		v ~= solve (s);
	}
	s.popFront;
	auto n = v.length.to !(int);
	sort (v);
	enforce (equal (v, n.iota));
	return n;
}

void main ()
{
	string s;
	while ((s = readln.strip) != "")
	{
		auto n = solve (s);
		enforce (s.empty);
		writeln (n);
	}
}
